package dev.kske.chess;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>TextureLoader.java</strong><br>
 * Created: <strong>01.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class TextureLoader {

	private TextureLoader() {}

	/**
	 * Loads an image from a file and scales it to a square.
	 * 
	 * @param file  The image file
	 * @param scale The side length of the square to which the image will be scaled
	 * @return The scaled image
	 */
	public static Image loadScaledImage(File file, int scale) {
		BufferedImage in = null;
		try {
			in = ImageIO.read(file);
		} catch (IOException e) {
			e.printStackTrace();
		}
		Image scaled = in.getScaledInstance(scale, scale, Image.SCALE_SMOOTH);
		return scaled;
	}
}
