package dev.kske.chess.piece;

import dev.kske.chess.Board;
import dev.kske.chess.Move;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>Bishop.java</strong><br>
 * Created: <strong>01.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class Bishop extends Piece {

	public Bishop(Color color, Board board) {
		super(color, board);
	}

	@Override
	public boolean isValidMove(Move move) {
		return move.isDiagonal() && isFreePath(move);
	}

	@Override
	protected boolean isFreePath(Move move) {
		for (int i = move.pos.x + move.xSign, j = move.pos.y
				+ move.ySign; i != move.dest.x; i += move.xSign, j += move.ySign)
			if (board.getBoardArr()[i][j] != null) return false;
		return checkDestination(move);
	}

	@Override
	public Type getType() { return Type.BISHOP; }
}
