package dev.kske.chess.piece;

import dev.kske.chess.Board;
import dev.kske.chess.Move;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>Knight.java</strong><br>
 * Created: <strong>01.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class Knight extends Piece {

	public Knight(Color color, Board board) {
		super(color, board);
	}

	@Override
	public boolean isValidMove(Move move) {
		return Math.abs(move.xDist - move.yDist) == 1 && move.xDist != 0 && move.yDist != 0 && isFreePath(move);
	}

	@Override
	public Type getType() { return Type.KNIGHT; }
}
