package dev.kske.chess.piece;

import dev.kske.chess.Board;
import dev.kske.chess.Move;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>Rook.java</strong><br>
 * Created: <strong>01.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class Rook extends Piece {

	public Rook(Color color, Board board) {
		super(color, board);
	}

	@Override
	public boolean isValidMove(Move move) {
		return (move.isHorizontal() || move.isVertical()) && isFreePath(move);
	}

	@Override
	protected boolean isFreePath(Move move) {
		if (move.isHorizontal()) {
			for (int i = move.pos.x + move.xSign; i != move.dest.x; i += move.xSign)
				if (board.getBoardArr()[i][move.pos.y] != null) return false;
		} else {
			for (int i = move.pos.y + move.ySign; i != move.dest.y; i += move.ySign)
				if (board.getBoardArr()[move.pos.x][i] != null) return false;
		}
		return checkDestination(move);
	}

	@Override
	public Type getType() { return Type.ROOK; }
}
